import * as Types from '../types/types';
export default class Keys {
    /**
     * Returns full list of available keys
     */
    static readonly list: Types.KeyDefinition[];
    /**
     * Returns a valid BTT shortcut notation basing on given string
     * @param shortcut
     */
    static mapShortcutNotationToBTT(shortcut: string): string;
    /**
     * Returns whether passed string is valid shortcut (key combo)
     * @param combo
     */
    static isValidShortcut(combo: Types.KeyCombo): boolean;
    /**
     * For details implementation look up to: https://community.folivora.ai/t/could-you-provide-a-formula-for-determining-keyboard-shortcuts-values/3606/2?u=worie
     * @param shortcut
     * @param differentiateLeftRight
     */
    static createBitmaskForShortcut(shortcut: string, differentiateLeftRight: boolean): number;
    /**
     * Returns the keycode of specific key
     * @param key
     */
    static getKeyCode(key: string): number;
    /**
     * Returns boolean whether this particular combo is requesting a location differentiation.
     * Basically checks the first letter of the key for 'l' or 'r', excluding mentioned letters.
     * @param combo
     */
    static isDifferentiating(combo: Types.KeyCombo): boolean;
}
